--- src/libdvdcss.c	2014-08-24 14:02:46.000000000 +0100
+++ src/libdvdcss.c	2014-08-31 19:09:58.000000000 +0100
@@ -100,6 +100,7 @@
 #include <stdio.h>
 #include <stdlib.h>
 #include <string.h>
+#include <dirent.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #ifdef HAVE_SYS_PARAM_H
@@ -153,11 +154,13 @@
 LIBDVDCSS_EXPORT dvdcss_t dvdcss_open ( char *psz_target )
 {
     char psz_buffer[PATH_MAX];
+    DIR *dir;
     int i_ret;
 
     char *psz_method = getenv( "DVDCSS_METHOD" );
     char *psz_verbose = getenv( "DVDCSS_VERBOSE" );
     char *psz_cache = getenv( "DVDCSS_CACHE" );
+    char *psz_xdgdata = getenv("XDG_DATA_HOME");
 #ifdef DVDCSS_RAW_OPEN
     char *psz_raw_device = getenv( "DVDCSS_RAW_DEVICE" );
 #endif
@@ -287,6 +290,15 @@
             snprintf( psz_buffer + home_pos, PATH_MAX - home_pos,
                       "%s/.dvdcss", psz_home );
             psz_buffer[PATH_MAX-1] = '\0';
+            if ( (dir = opendir( psz_buffer)) != NULL )
+              closedir ( dir);
+            else if( psz_xdgdata )
+                snprintf( psz_buffer, PATH_MAX - 1, "%s/dvdcss", psz_xdgdata );
+              else
+                snprintf( psz_buffer + home_pos, PATH_MAX - home_pos,
+                      "%s/.local/share/dvdcss", psz_home );
+            psz_buffer[PATH_MAX-1] = '\0';
+
             psz_cache = psz_buffer;
         }
 #endif
